/**************************************************************************
*
* Nom du projet     : Application cours langage C
* Objet 				  : Compte le nombre de caractres, de lignes
*							 et de colonnes sur l'entre standart stdin
*							 Les sparateurs de mots sont la tabulation,
*							 le retour chariot et l'espace.
*							 On utilise le programme sous l'invite en tapant:
*							 cpttxt<nomfichier.txt ou nomfichier.txt contient
*							 le texte a examiner
***************************************************************************
*
* Rpertoire                : C\cpttxt2
* Nom du fichier            : cpttxt2.c
* Nom du fichier d'analyse  :
* Auteur                    : David ROUSSE
* Date de creation          : 28 / 09 /1997
* Date de mise a jour       :
* Valide par                :
* Date de validation        :
* Indice du module          : 0
*
***************************************************************************
*
***************************************************************************
************************ MODIFICATIONS APPORTEES **************************
*
* Le ://              Indice :
* Origine et Descriptif de la modification :
*
***************************************************************************
*/

#include <stdio.h>
#include <stdlib.h>

#define VRAI 1
#define FAUX 0

void main(void)
{
	long nc=0L; /* nombre de caractres */
   int nl=0, nm=0, mot=FAUX; /* nombre de lignes, mots   */
   						        /* et indicateur pour 1 mot */
   char car;

   /* lecture complte du fichier jusqu' EOF */
   while((car = getchar()) != EOF)
   {
   	nc++; /* on a lu un nouveau caractre */

      if( car != '\n' && car != ' ' && car != '\t' && !mot)
      {
      	mot = VRAI; /* on est dans un mot */
         nm++; /* on a un mot de plus */
      }

      if( car == '\n' || car == ' ' || car == '\t' && mot)
        	mot = FAUX; /* on sort d'un mot */

      if (car == '\n')
         nl++; /* on a une nouvelle ligne */

   }

   /* on doit incrementer le nombre de lignes 							  */
   /* car on sort du while lorsqu'on rencontre le dernier caractere */
   nl++;

   /* rsultat du traitement */
   printf("\nLe texte contenait:");
   printf("\n\t-nombre de caracteres: %ld", nc);
   printf("\n\t-nombre de lignes: %d", nl);
   printf("\n\t-nombre de mots: %d", nm);

   /* pause pour la lecture du rsultat */
   printf("\n\n--- Copyright David Rousse 1999 ---\n");

}







