#ifndef _LISTE_H
#define _LISTE_H

/* Fichier Liste.h */
/* Manipulation d'une liste simplement chainee d'entiers */

/* STRUCTURES DE DONNEES */
/* ********************* */

/* Definition d'une cellule de la liste */
typedef struct cel { int valeur;
                     struct cel *suivant;
                   } Cellule;
 
/* Definition du type Liste comme un pointeur sur une cellule */
typedef Cellule *Liste;

/* PROTOTYPES DES FONCTIONS DE MANIPULATION */
/* **************************************** */

Liste creation();       /* Cree une liste vide */
Liste destruction (Liste); /* Detruit une liste donnee */
int valeur(Liste, int); /* Retourne la valeur du ieme element d'une liste */
int longueur(Liste); /* Longueur d'une liste */
Liste insertion(Liste, int, int); 
/* Insre une valeur (3 param) au rang i(2 param) */
Liste retrait(Liste, int);
/* Supprime la valeur au rang i d'une liste */
int listeVide(Liste) ; /* Retourne 1 si la liste est vide, 0 sinon */
void edition(Liste) ; /* Edition de la liste */
#endif  
