#ifndef _PILE_H
#define _PILE_H

#include "liste.h"

/* STRUCTURES DE DONNEES */
/* ********************* */

/* Definition d'pile */
typedef Liste Pile;

/* PROTOTYPES DES FONCTIONS DE MANIPULATION D'UNE PILE */
/* *************************************************** */

Pile creationPile();       /* Cree une pile vide */
Pile destructionPile(Pile); /* Detruit une pile donnee */
int valeurPile(Pile); /* Retourne la valeur courante d'une pile */
Pile insertionPile(Pile, int); /* Insre une valeur */
Pile retraitPile(Pile); /* Supprime la valeur courante d'une pile */
int pileVide(Pile) ; /* Retourne 1 si la pile est vide, 0 sinon */
void editionPile(Pile) ; /* Edition de la pile */

#endif
